#ifndef ZONE_INT_H
#define ZONE_INT_H

#include "zoneStruct.h"

typedef enum ZONE_POSTER_TYPE {
  ZONE_POSTER_MAP,
  ZONE_POSTER_ROB_IN,
  ZONE_POSTER_M1_IN,
  ZONE_POSTER_M2_IN,
  ZONE_POSTER_M3_IN,
  ZONE_NB_POSTER_TYPES
} ZONE_POSTER_TYPE;

typedef STATUS (*POSTER_OCCUPIED_WRITE_FUNC)(POSTER_ID, ZONES_OCCUPIED *);

/* One ZONE_TYPE_DESC per each zone type (TARGET, OBST or SPECIAL) */
typedef struct ZONE_TYPE_DESC {
  GEN_STRING128 fileName;
  POSTER_ID posterId[ZONE_NB_POSTER_TYPES];
  POSTER_OCCUPIED_WRITE_FUNC posterOccupiedWriteFunc[ZONE_NBMAX_MOBILES];
  ZONES_MAP zonesMap;
  ZONE_POINT growedPoints[ZONE_NBMAX_PTS];
  ZONES_OCCUPIED zonesOccupied[ZONE_NBMAX_MOBILES];
} ZONE_TYPE_DESC;

typedef enum ZONE_POSTER_POS_TYPE {
  ZONE_POSTER_POM_POS,
  ZONE_POSTER_POM_ME_POS,
  ZONE_POSTER_POM_SENSOR_POS,
  ZONE_POSTER_POM_EULER_POS
} ZONE_POSTER_POS_TYPE;

typedef struct ZONE_MOBILE_STATE {
  POSTER_ID                pomPosterId;
  ZONE_POSTER_POS_TYPE  pomPosterStructType;
  GEN_STRING64 posPosterName;
  ZONE_BOOL monitorZoneType[ZONE_NB_TYPES];
  POM_POS		pomPos;		/* pom pos */
  ZONE_CONFIG currentConfig; /* robot config */
  int lastEnterEventZoneIndex;
  int lastLeaveEventZoneIndex;
  ZONE_TYPE lastEnterEventZoneType;
  ZONE_TYPE lastLeaveEventZoneType;
} ZONE_MOBILE_STATE;

#endif
